/*
 * Segment 6 Intelligente Bewertungsverfahren, SWE 6.1 Stauverlaufsanalyse
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.ibv.anastau.migration.daf;

import java.io.Serializable;
import java.util.Objects;

/**
 * @author peuker
 *
 */
public abstract class AbstractDavZustand
implements Serializable, Comparable<AbstractDavZustand> {

	private final int code;
	private final String name;

	public AbstractDavZustand(final int code, final String name) {
		super();
		this.code = code;
		this.name = name;
	}

	public final int getCode() {
		return code;
	}

	@Override
	public final String toString() {
		return name;
	}


	@Override
	public int compareTo(final AbstractDavZustand o) {
		return Integer.compare(code, o.code);
	}

    @Override
    public int hashCode() {
        return Objects.hash(code);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof AbstractDavZustand)) {
            return false;
        }
        AbstractDavZustand other = (AbstractDavZustand) obj;
        return code == other.code;
    }
}
