/*
 * Segment 6 Intelligente Bewertungsverfahren, SWE 6.1 Stauverlaufsanalyse
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.ibv.anastau.portale;

import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.ibv.anastau.domain.SvaBetriebsmeldungssender;
import de.bsvrz.sys.funclib.operatingMessage.MessageGrade;
import de.bsvrz.sys.funclib.operatingMessage.MessageSender;
import de.bsvrz.sys.funclib.operatingMessage.MessageType;

public class DavSvaBetriebsmeldungssender implements SvaBetriebsmeldungssender {

    private final ClientDavInterface dav;

    public DavSvaBetriebsmeldungssender(ClientDavInterface dav) {
        this.dav = dav;
    }

    @Override
    public void fehler(String pid, String message) {
        SystemObject so = null;
        if (pid != null) {
            so = dav.getDataModel().getObject(pid);
        }
        send(MessageGrade.ERROR, so, message);
    }

    @Override
    public void warnung(String pid, String message) {
        SystemObject so = null;
        if (pid != null) {
            dav.getDataModel().getObject(pid);
        }
        send(MessageGrade.WARNING, so, message);
    }

    private void send(MessageGrade grade, SystemObject so, String message) {
        MessageSender sender = MessageSender.getInstance();
        sender.sendMessage(MessageType.APPLICATION_DOMAIN, "", grade, so, null, message);
    }
}
